unit pongu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Math;

type
  TPong = class(TForm)
    PaddleR: TLabel;
    Ball: TLabel;
    PaddleL: TLabel;
    ScoreL: TLabel;
    ScoreR: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Loop;
    procedure BeepBounceH;
    procedure BeepBounceV;
    procedure BeepBounceP;
    procedure BeepFor(Tone : word; MSecs : integer);
    procedure StartBeep(Freq : Word);
    procedure StopBeep;
    function _GetPort(address:word):word;
    procedure _SetPort(address, Value:Word);
  end;

const
  BounceH: integer = 1000;
  BounceV: integer = 2500;
  BounceP: integer = 5000;
  KeyStat1: integer = -127;
  KeyStat2: integer = -128;
  KeyL1: integer = $51;
  KeyL2: integer = $41;
  KeyR1: integer = $26;
  KeyR2: integer = $28;
  PointsL: integer = 0;
  PointsR: integer = 0;
  PaddleSpeed: integer = 5;
  PaddleDiff: integer = 5;

var
  Pong: TPong;
  Delay: integer = 1;
  DirectionH: string = 'L';
  DirectionV: string = 'U';
  MinH: integer = 0;
  MaxH: integer = 400;
  MinV: integer = 0;
  MaxV: integer = 300;
  Diff: integer = 1;
  Quit: boolean = false;
  ModeH: integer = 1;
  ModeV: integer = 1;

implementation

{$R *.DFM}

procedure TPong.FormActivate(Sender: TObject);
var
  StateL: integer;
  StateR: integer;
begin
  ShowCursor(False);
  if not(Trim(ParamStr(1)) = '') then
    Delay := StrToInt(ParamStr(1));
  if not(Trim(ParamStr(2)) = '') then
    PaddleSpeed := StrToInt(ParamStr(2));
  StateL := 0;
  StateR := 0;
  Pong.Show;
  Pong.Width := Screen.Width;
  Pong.Height := Screen.Height;
  FormResize(Pong);
  repeat
    Sleep(Delay);
    StopBeep;
    Application.ProcessMessages;
    Loop;
    if (GetKeyState(KeyL1) = KeyStat1) or (GetKeyState(KeyL1) = KeyStat2) then
      if StateL = PaddleSpeed then
      begin
        StateL := 0;
        if not(PaddleL.Top < MinV + 4) then
          PaddleL.Top := PaddleL.Top - PaddleDiff;
      end
      else
        Inc(StateL);
    if (GetKeyState(KeyL2) = KeyStat1) or (GetKeyState(KeyL2) = KeyStat2) then
      if StateL = PaddleSpeed then
      begin
        StateL := 0;
        if not(PaddleL.Top + PaddleL.Height > MaxV - 36) then
          PaddleL.Top := PaddleL.Top + PaddleDiff;
      end
      else
        Inc(StateL);
    if (GetKeyState(KeyR1) = KeyStat1) or (GetKeyState(KeyR1) = KeyStat2) then
      if StateR = PaddleSpeed then
      begin
        StateR := 0;
        if not(PaddleR.Top < MinV + 4) then
          PaddleR.Top := PaddleR.Top - PaddleDiff;
      end
      else
        Inc(StateR);
    if (GetKeyState(KeyR2) = KeyStat1) or (GetKeyState(KeyR2) = KeyStat2) then
      if StateR = PaddleSpeed then
      begin
        StateR := 0;
        if not(PaddleR.Top + PaddleR.Height > MaxV - 36) then
          PaddleR.Top := PaddleR.Top + PaddleDiff;
      end
      else
        Inc(StateR);
  until Quit;
end;

procedure TPong.Loop;
begin
  if (Ball.Top >= PaddleL.Top) and (Ball.Top <= PaddleL.Top + PaddleL.Height) and (Ball.Left <= PaddleL.Left + PaddleL.Width) then
  begin
    if Ball.Top - PaddleL.Top <= 14 then
    begin
      ModeH := 1;
      ModeV := 2;
    end
    else if Ball.Top - PaddleL.Top <= 28 then
    begin
      ModeH := 1;
      ModeV := 1;
    end
    else
    begin
      ModeH := 2;
      ModeV := 1;
    end;
    DirectionH := 'R';
    BeepBounceP;
  end;
  if (Ball.Top >= PaddleR.Top) and (Ball.Top <= PaddleR.Top + PaddleR.Height) and (Ball.Left + Ball.Width >= PaddleR.Left) then
  begin
    if Ball.Top - PaddleR.Top <= 7 then
    begin
      ModeH := 1;
      ModeV := 3;
    end
    else if Ball.Top - PaddleR.Top <= 14 then
    begin
      ModeH := 1;
      ModeV := 2;
    end
    else if Ball.Top - PaddleR.Top <= 21 then
    begin
      ModeH := 1;
      ModeV := 1;
    end
    else if Ball.Top - PaddleR.Top <= 28 then
    begin
      ModeH := 2;
      ModeV := 1;
    end
    else
    begin
      ModeH := 3;
      ModeV := 1;
    end;
    DirectionH := 'L';
    BeepBounceP;
  end;
  if Ball.Left <= MinH then
  begin
    DirectionH := 'R';
    BeepBounceH;
    Inc(PointsR);
    ScoreR.Caption := IntToStr(PointsR) + ' ';
  end
  else if Ball.Left >= MaxH - Ball.Width - 8 then
  begin
    DirectionH := 'L';
    BeepBounceH;
    Inc(PointsL);
    ScoreL.Caption := ' ' + IntToStr(PointsL);
  end;
  if Ball.Top <= MinV - ModeV then
  begin
    DirectionV := 'D';
    BeepBounceV;
  end
  else if Ball.Top + Ball.Height >= MaxV - 27 - ModeV then
  begin
    DirectionV := 'U';
    BeepBounceV;
  end;
  if DirectionH = 'L' then
    Ball.Left := Ball.Left - ModeH
  else if DirectionH = 'R' then
    Ball.Left := Ball.Left + ModeH;
  if DirectionV = 'U' then
    Ball.Top := Ball.Top - ModeV
  else if DirectionV = 'D' then
    Ball.Top := Ball.Top + ModeV;
end;

procedure TPong.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Quit := True;
  ShowCursor(True);
end;

procedure TPong.BeepBounceH;
begin
  StartBeep(BounceH);
end;

procedure TPong.BeepBounceV;
begin
  StartBeep(BounceV);
end;

procedure TPong.BeepBounceP;
begin
  StartBeep(BounceP);
end;

procedure TPong.BeepFor(Tone : word; MSecs : integer);
begin
  StartBeep(Tone);
  Sleep(MSecs);
  StopBeep;
end;

procedure TPong.StartBeep(Freq : Word);
var
  B: Byte;
begin
  Freq := Word(1193181 div LongInt(Freq));
  B := Byte(_GetPort($61));
  if (B and 3) = 0 then
  begin
    _SetPort($61, Word(B or 3));
    _SetPort($43, $B6);
  end;
  _SetPort($42, Freq);
  _SetPort($42, Freq shr 8);
end;

procedure TPong.StopBeep;
var
 Value: Word;
begin
  Value := _GetPort($61) and $FC;
  _SetPort($61, Value);
end;

function TPong._GetPort(address:word):word;
var
  bValue: byte;
begin
  asm
    mov dx, address
    in al, dx
    mov bValue, al
  end;
  Result := bValue;
end;

procedure TPong._SetPort(address, Value:Word);
var
 bValue: byte;
begin
  bValue := Trunc(Value and 255);
  asm
    mov dx, address
    mov al, bValue
    out dx, al
  end;
end;

procedure TPong.FormResize(Sender: TObject);
begin
  MaxH := Pong.Width;
  MaxV := Pong.Height;
  PaddleR.Left := MaxH - PaddleR.Width - 16;
  ScoreL.Top := Pong.Height - ScoreL.Height - 34;
  ScoreL.Left := 0 + 14;
  ScoreR.Top := Pong.Height - ScoreR.Height - 34;
  ScoreR.Left := Pong.Width - ScoreR.Width - 24;
end;

end.
